//****************************************************************************
//
// SPDX-License-Identifier: MIT-0
// Copyright(c) 2017-2020 Intel Corporation.
//
//****************************************************************************
// This is a generated system top level RTL file. 



module ghrd_s10_top (
// Clock and Reset
input  wire [1-1:0]  fpga_clk_100,
input  wire [1-1:0]  fpga_reset_n,
output wire [4-1:0]  fpga_led_pio,
input  wire [4-1:0]  fpga_dipsw_pio,
input  wire [4-1:0]  fpga_button_pio,
input	    wire	  			pcie_hip_refclk_clk,
input 		wire [8-1:0] 			pcie_hip_serial_rx_in,  
output 		wire [8-1:0] 			pcie_hip_serial_tx_out,
input	    wire 	  			pcie_hip_npor_pin_perst,
output     mux_io_1v8_20,       //fpga_pcie_perstn
//HPS
// HPS EMIF
output wire [0:0]    emif_hps_mem_mem_ck,
output wire [0:0]    emif_hps_mem_mem_ck_n,
output wire [16:0]   emif_hps_mem_mem_a,
output wire [0:0]    emif_hps_mem_mem_act_n,
output wire [1:0]    emif_hps_mem_mem_ba,
output wire [0:0]    emif_hps_mem_mem_bg,
output wire [0:0]    emif_hps_mem_mem_cke,
output wire [0:0]    emif_hps_mem_mem_cs_n,
output wire [0:0]    emif_hps_mem_mem_odt,
output wire [0:0]    emif_hps_mem_mem_reset_n,
output wire [0:0]    emif_hps_mem_mem_par,
input  wire [0:0]    emif_hps_mem_mem_alert_n,
input  wire          emif_hps_oct_oct_rzqin,
input  wire          emif_hps_pll_ref_clk,
inout  wire [9-1:0]  emif_hps_mem_mem_dbi_n,
inout  wire [72-1:0] emif_hps_mem_mem_dq,
inout  wire [9-1:0]  emif_hps_mem_mem_dqs,
inout  wire [9-1:0]  emif_hps_mem_mem_dqs_n,
input  wire          hps_jtag_tck,
input  wire          hps_jtag_tms,
output wire          hps_jtag_tdo,
input  wire          hps_jtag_tdi,
output wire          hps_sdmmc_CCLK, 
inout  wire          hps_sdmmc_CMD,          
inout  wire          hps_sdmmc_D0,          
inout  wire          hps_sdmmc_D1,          
inout  wire          hps_sdmmc_D2,        
inout  wire          hps_sdmmc_D3,        
inout  wire          hps_usb0_DATA0,         
inout  wire          hps_usb0_DATA1,      
inout  wire          hps_usb0_DATA2,        
inout  wire          hps_usb0_DATA3,       
inout  wire          hps_usb0_DATA4,        
inout  wire          hps_usb0_DATA5,      
inout  wire          hps_usb0_DATA6,      
inout  wire          hps_usb0_DATA7,         
input  wire          hps_usb0_CLK,         
output wire          hps_usb0_STP,       
input  wire          hps_usb0_DIR,        
input  wire          hps_usb0_NXT, 
output wire          hps_emac0_TX_CLK,       //TODO: may need to change RMII TX CLK to be input instead, check
input  wire          hps_emac0_RX_CLK,      
output wire          hps_emac0_TX_CTL,
input  wire          hps_emac0_RX_CTL,      
output wire          hps_emac0_TXD0,       
output wire          hps_emac0_TXD1,
input  wire          hps_emac0_RXD0,     
input  wire          hps_emac0_RXD1,                
output wire          hps_emac0_TXD2,        
output wire          hps_emac0_TXD3,
input  wire          hps_emac0_RXD2,        
input  wire          hps_emac0_RXD3, 
inout  wire          hps_emac0_MDIO,         
output wire          hps_emac0_MDC,
input  wire          hps_uart0_RX,       
output wire          hps_uart0_TX, 
inout  wire          hps_i2c1_SDA,        
inout  wire          hps_i2c1_SCL, 
inout  wire          hps_gpio1_io0,
inout  wire          hps_gpio1_io1,
inout  wire          hps_gpio1_io4,
inout  wire          hps_gpio1_io5,
inout  wire          hps_gpio1_io19,
inout  wire          hps_gpio1_io20,
inout  wire          hps_gpio1_io21,
input  wire          hps_ref_clk
);

wire         system_clk_100;
wire         system_clk_100_internal;
wire         ninit_done;
wire         src_reset_n;
wire         system_reset_n;
wire         pcie_npor_npor;
wire [4:0]   pcie_a10_hip_status_ltssmstate;
wire         h2f_reset;
assign system_reset_n = fpga_reset_n & src_reset_n & ~h2f_reset & ~ninit_done;



assign system_clk_100   = fpga_clk_100;

assign system_clk_100_internal  = system_clk_100;

wire [3:0]     fpga_debounced_buttons;
wire [2:0]     fpga_led_internal;
wire           heartbeat_led;
reg  [22:0]    heartbeat_count;
assign fpga_led_pio = {heartbeat_led,fpga_led_internal};
assign heartbeat_led = ~heartbeat_count[22];

wire [31:0]    f2h_irq1_irq;




wire [42:0]    stm_hw_events;

assign stm_hw_events    = 43'b0;

wire [31:0] gp_output;
wire [31:0] gp_input;
wire [13:0] pcie_link_status;

assign f2h_irq1_irq    = {32'b0};

assign pcie_npor_npor = pcie_hip_npor_pin_perst;

assign mux_io_1v8_20 = ~gp_output[1];

// Qsys Top module
qsys_top soc_inst (
.src_prb_rst_sources_source             (src_reset_n),
.reset_reset_n                          (system_reset_n), 
.clk_100_clk                            (system_clk_100_internal),
.ninit_done_ninit_done                  (ninit_done),
.led_pio_external_connection_in_port    (fpga_led_internal),                    
.led_pio_external_connection_out_port   (fpga_led_internal),
.dipsw_pio_external_connection_export   (fpga_dipsw_pio), 
.button_pio_external_connection_export  (fpga_debounced_buttons), 
.pcie_hip_refclk_clk 			(pcie_hip_refclk_clk),
.pcie_hip_pipe_sim_pipe_pclk_in	(1'b0),    
.pcie_hip_pipe_phystatus0	(1'b0),  
.pcie_hip_pipe_rxdata0		(32'b0),  
.pcie_hip_pipe_rxdatak0		(4'b0),                                   
.pcie_hip_pipe_rxelecidle0	(1'b0),                             
.pcie_hip_pipe_rxstatus0		(3'b0),                             
.pcie_hip_pipe_rxvalid0		(1'b0),                                 
.pcie_hip_pipe_rxdataskip0	(1'b0),                                    
.pcie_hip_pipe_rxblkst0		(1'b0),                       
.pcie_hip_pipe_rxsynchd0		(2'b0),
.pcie_hip_serial_rx_in0       	(pcie_hip_serial_rx_in[0]),                                
.pcie_hip_serial_tx_out0      	(pcie_hip_serial_tx_out[0]), 
.pcie_hip_pipe_phystatus1	(1'b0),  
.pcie_hip_pipe_rxdata1		(32'b0),  
.pcie_hip_pipe_rxdatak1		(4'b0),                                   
.pcie_hip_pipe_rxelecidle1	(1'b0),                             
.pcie_hip_pipe_rxstatus1		(3'b0),                             
.pcie_hip_pipe_rxvalid1		(1'b0),                                 
.pcie_hip_pipe_rxdataskip1	(1'b0),                                    
.pcie_hip_pipe_rxblkst1		(1'b0),                       
.pcie_hip_pipe_rxsynchd1		(2'b0),
.pcie_hip_serial_rx_in1       	(pcie_hip_serial_rx_in[1]),                                
.pcie_hip_serial_tx_out1      	(pcie_hip_serial_tx_out[1]), 
.pcie_hip_pipe_phystatus2	(1'b0),  
.pcie_hip_pipe_rxdata2		(32'b0),  
.pcie_hip_pipe_rxdatak2		(4'b0),                                   
.pcie_hip_pipe_rxelecidle2	(1'b0),                             
.pcie_hip_pipe_rxstatus2		(3'b0),                             
.pcie_hip_pipe_rxvalid2		(1'b0),                                 
.pcie_hip_pipe_rxdataskip2	(1'b0),                                    
.pcie_hip_pipe_rxblkst2		(1'b0),                       
.pcie_hip_pipe_rxsynchd2		(2'b0),
.pcie_hip_serial_rx_in2       	(pcie_hip_serial_rx_in[2]),                                
.pcie_hip_serial_tx_out2      	(pcie_hip_serial_tx_out[2]), 
.pcie_hip_pipe_phystatus3	(1'b0),  
.pcie_hip_pipe_rxdata3		(32'b0),  
.pcie_hip_pipe_rxdatak3		(4'b0),                                   
.pcie_hip_pipe_rxelecidle3	(1'b0),                             
.pcie_hip_pipe_rxstatus3		(3'b0),                             
.pcie_hip_pipe_rxvalid3		(1'b0),                                 
.pcie_hip_pipe_rxdataskip3	(1'b0),                                    
.pcie_hip_pipe_rxblkst3		(1'b0),                       
.pcie_hip_pipe_rxsynchd3		(2'b0),
.pcie_hip_serial_rx_in3       	(pcie_hip_serial_rx_in[3]),                                
.pcie_hip_serial_tx_out3      	(pcie_hip_serial_tx_out[3]), 
.pcie_hip_pipe_phystatus4	(1'b0),  
.pcie_hip_pipe_rxdata4		(32'b0),  
.pcie_hip_pipe_rxdatak4		(4'b0),                                   
.pcie_hip_pipe_rxelecidle4	(1'b0),                             
.pcie_hip_pipe_rxstatus4		(3'b0),                             
.pcie_hip_pipe_rxvalid4		(1'b0),                                 
.pcie_hip_pipe_rxdataskip4	(1'b0),                                    
.pcie_hip_pipe_rxblkst4		(1'b0),                       
.pcie_hip_pipe_rxsynchd4		(2'b0),
.pcie_hip_serial_rx_in4       	(pcie_hip_serial_rx_in[4]),                                
.pcie_hip_serial_tx_out4      	(pcie_hip_serial_tx_out[4]), 
.pcie_hip_pipe_phystatus5	(1'b0),  
.pcie_hip_pipe_rxdata5		(32'b0),  
.pcie_hip_pipe_rxdatak5		(4'b0),                                   
.pcie_hip_pipe_rxelecidle5	(1'b0),                             
.pcie_hip_pipe_rxstatus5		(3'b0),                             
.pcie_hip_pipe_rxvalid5		(1'b0),                                 
.pcie_hip_pipe_rxdataskip5	(1'b0),                                    
.pcie_hip_pipe_rxblkst5		(1'b0),                       
.pcie_hip_pipe_rxsynchd5		(2'b0),
.pcie_hip_serial_rx_in5       	(pcie_hip_serial_rx_in[5]),                                
.pcie_hip_serial_tx_out5      	(pcie_hip_serial_tx_out[5]), 
.pcie_hip_pipe_phystatus6	(1'b0),  
.pcie_hip_pipe_rxdata6		(32'b0),  
.pcie_hip_pipe_rxdatak6		(4'b0),                                   
.pcie_hip_pipe_rxelecidle6	(1'b0),                             
.pcie_hip_pipe_rxstatus6		(3'b0),                             
.pcie_hip_pipe_rxvalid6		(1'b0),                                 
.pcie_hip_pipe_rxdataskip6	(1'b0),                                    
.pcie_hip_pipe_rxblkst6		(1'b0),                       
.pcie_hip_pipe_rxsynchd6		(2'b0),
.pcie_hip_serial_rx_in6       	(pcie_hip_serial_rx_in[6]),                                
.pcie_hip_serial_tx_out6      	(pcie_hip_serial_tx_out[6]), 
.pcie_hip_pipe_phystatus7	(1'b0),  
.pcie_hip_pipe_rxdata7		(32'b0),  
.pcie_hip_pipe_rxdatak7		(4'b0),                                   
.pcie_hip_pipe_rxelecidle7	(1'b0),                             
.pcie_hip_pipe_rxstatus7		(3'b0),                             
.pcie_hip_pipe_rxvalid7		(1'b0),                                 
.pcie_hip_pipe_rxdataskip7	(1'b0),                                    
.pcie_hip_pipe_rxblkst7		(1'b0),                       
.pcie_hip_pipe_rxsynchd7		(2'b0),
.pcie_hip_serial_rx_in7       	(pcie_hip_serial_rx_in[7]),                                
.pcie_hip_serial_tx_out7      	(pcie_hip_serial_tx_out[7]), 
.pcie_hip_pipe_sim_ltssmstate       (pcie_pipe_sim_ltssmstate),
.pcie_hip_status_ltssmstate         (pcie_link_status[5:0]),
.pcie_hip_status_link_up            (pcie_link_status[6]),
.pcie_hip_status_lane_act           (pcie_link_status[11:7]),
.pcie_hip_currentspeed_currentspeed (pcie_link_status[13:12]),
.pcie_hip_npor_npor                 (pcie_npor_npor),
.pcie_hip_npor_pin_perst            (pcie_hip_npor_pin_perst),
.pcie_link_stat_pio_export          (pcie_link_status),
.s10_hps_f2h_stm_hw_events_stm_hwevents (stm_hw_events),     
.emif_hps_pll_ref_clk_clk               (emif_hps_pll_ref_clk),   
.emif_hps_mem_mem_ck                    (emif_hps_mem_mem_ck),   
.emif_hps_mem_mem_ck_n                  (emif_hps_mem_mem_ck_n),  
.emif_hps_mem_mem_a                     (emif_hps_mem_mem_a),       
.emif_hps_mem_mem_act_n                 (emif_hps_mem_mem_act_n),   
.emif_hps_mem_mem_ba                    (emif_hps_mem_mem_ba),      
.emif_hps_mem_mem_bg                    (emif_hps_mem_mem_bg),      
.emif_hps_mem_mem_cke                   (emif_hps_mem_mem_cke),    
.emif_hps_mem_mem_cs_n                  (emif_hps_mem_mem_cs_n),    
.emif_hps_mem_mem_odt                   (emif_hps_mem_mem_odt),     
.emif_hps_mem_mem_reset_n               (emif_hps_mem_mem_reset_n),
.emif_hps_mem_mem_par                   (emif_hps_mem_mem_par),          
.emif_hps_mem_mem_alert_n               (emif_hps_mem_mem_alert_n),    
.emif_hps_mem_mem_dqs                   (emif_hps_mem_mem_dqs),       
.emif_hps_mem_mem_dqs_n                 (emif_hps_mem_mem_dqs_n),     
.emif_hps_mem_mem_dq                    (emif_hps_mem_mem_dq), 
.emif_hps_mem_mem_dbi_n                 (emif_hps_mem_mem_dbi_n), 
.emif_hps_oct_oct_rzqin                 (emif_hps_oct_oct_rzqin), 
.hps_io_hps_io_jtag_tck                 (hps_jtag_tck),                
.hps_io_hps_io_jtag_tms                 (hps_jtag_tms),                
.hps_io_hps_io_jtag_tdo                 (hps_jtag_tdo),                 
.hps_io_hps_io_jtag_tdi                 (hps_jtag_tdi),    
.hps_io_hps_io_phery_emac0_TX_CLK       (hps_emac0_TX_CLK),     
.hps_io_hps_io_phery_emac0_RX_CLK       (hps_emac0_RX_CLK),     
.hps_io_hps_io_phery_emac0_TX_CTL       (hps_emac0_TX_CTL),    
.hps_io_hps_io_phery_emac0_RX_CTL       (hps_emac0_RX_CTL),    
.hps_io_hps_io_phery_emac0_TXD0         (hps_emac0_TXD0),     
.hps_io_hps_io_phery_emac0_TXD1         (hps_emac0_TXD1),
.hps_io_hps_io_phery_emac0_RXD0         (hps_emac0_RXD0),       
.hps_io_hps_io_phery_emac0_RXD1         (hps_emac0_RXD1),        
.hps_io_hps_io_phery_emac0_TXD2         (hps_emac0_TXD2),      
.hps_io_hps_io_phery_emac0_TXD3         (hps_emac0_TXD3),   
.hps_io_hps_io_phery_emac0_RXD2         (hps_emac0_RXD2),        
.hps_io_hps_io_phery_emac0_RXD3         (hps_emac0_RXD3),
.hps_io_hps_io_phery_emac0_MDIO         (hps_emac0_MDIO),       
.hps_io_hps_io_phery_emac0_MDC          (hps_emac0_MDC), 
.hps_io_hps_io_phery_sdmmc_CCLK         (hps_sdmmc_CCLK),   
.hps_io_hps_io_phery_sdmmc_CMD          (hps_sdmmc_CMD), 
.hps_io_hps_io_phery_sdmmc_D0           (hps_sdmmc_D0),          
.hps_io_hps_io_phery_sdmmc_D1           (hps_sdmmc_D1),          
.hps_io_hps_io_phery_sdmmc_D2           (hps_sdmmc_D2),         
.hps_io_hps_io_phery_sdmmc_D3           (hps_sdmmc_D3),        
.hps_io_hps_io_phery_i2c1_SDA           (hps_i2c1_SDA),     
.hps_io_hps_io_phery_i2c1_SCL           (hps_i2c1_SCL),
.hps_io_hps_io_phery_uart0_RX           (hps_uart0_RX),          
.hps_io_hps_io_phery_uart0_TX           (hps_uart0_TX), 
.hps_io_hps_io_phery_usb0_CLK           (hps_usb0_CLK), 
.hps_io_hps_io_phery_usb0_STP           (hps_usb0_STP), 
.hps_io_hps_io_phery_usb0_DIR           (hps_usb0_DIR),
.hps_io_hps_io_phery_usb0_NXT           (hps_usb0_NXT),
.hps_io_hps_io_phery_usb0_DATA0         (hps_usb0_DATA0),
.hps_io_hps_io_phery_usb0_DATA1         (hps_usb0_DATA1), 
.hps_io_hps_io_phery_usb0_DATA2         (hps_usb0_DATA2), 
.hps_io_hps_io_phery_usb0_DATA3         (hps_usb0_DATA3), 
.hps_io_hps_io_phery_usb0_DATA4         (hps_usb0_DATA4), 
.hps_io_hps_io_phery_usb0_DATA5         (hps_usb0_DATA5),
.hps_io_hps_io_phery_usb0_DATA6         (hps_usb0_DATA6), 
.hps_io_hps_io_phery_usb0_DATA7         (hps_usb0_DATA7),
.hps_io_hps_io_gpio_gpio1_io0           (hps_gpio1_io0),
.hps_io_hps_io_gpio_gpio1_io1           (hps_gpio1_io1),
.hps_io_hps_io_gpio_gpio1_io4           (hps_gpio1_io4),
.hps_io_hps_io_gpio_gpio1_io5           (hps_gpio1_io5),
.hps_io_hps_io_gpio_gpio1_io19           (hps_gpio1_io19),
.hps_io_hps_io_gpio_gpio1_io20           (hps_gpio1_io20),
.hps_io_hps_io_gpio_gpio1_io21           (hps_gpio1_io21),
.s10_hps_h2f_gp_gp_in                   (gp_input),
.s10_hps_h2f_gp_gp_out                  (gp_output),
.f2h_irq1_irq                           (f2h_irq1_irq),


.h2f_reset_reset                        (h2f_reset),
.hps_io_hps_io_hps_ocs_clk              (hps_ref_clk)
);  


// Debounce logic to clean out glitches within 1ms
debounce debounce_inst (
.clk          (system_clk_100_internal),
.reset_n      (system_reset_n),  
.data_in      (fpga_button_pio),
.data_out     (fpga_debounced_buttons)
);
defparam debounce_inst.WIDTH = 4;
defparam debounce_inst.POLARITY = "LOW";
defparam debounce_inst.TIMEOUT = 10000;               // at 100Mhz this is a debounce time of 1ms
defparam debounce_inst.TIMEOUT_WIDTH = 32;            // ceil(log2(TIMEOUT))

always @(posedge system_clk_100_internal or negedge system_reset_n) begin
  if (~system_reset_n)
    heartbeat_count <= 23'd0;
  else
    heartbeat_count <= heartbeat_count + 23'd1;
end


endmodule


